<?php
namespace moonlight\eticket;
class eticket extends \moonlight\module_base implements \moonlight\moonlight_module {
	public $co_db;
	protected $co_config;
	// General module information
	public function __construct($p_config_path = '') {
		$this->init(__NAMESPACE__, __CLASS__, $p_config_path);
		$this->c_usr_id = \E::get_session('usr_id');
	}
	public function get_shortname() {
		return 'eticket'; /*Will be use for the session */
	}
	public function get_fullname() {
		return 'eticket';
	}
	public function get_version() {
		return '1.0.0';
	}
	public function get_icon() {
		return '';
	}
	public function get_component_folder() {
		return $this->get_module_folder() . 'web/component/';
	}
	public function get_module_folder() {
		return 'eticket/';
	}
	public function swkid_authenticate_fallback($v_swkid_user){
		//check if user already exists in the system
		$v_code = (isset($_REQUEST['code'])) ? $_REQUEST['code'] : '';
		$v_code = (isset($_REQUEST['state'])) ? $_REQUEST['state'] : '';
		if ($v_swkid_user['login_by'] == 'sarawakid'){
			$v_cond['usr_short_name'] = $v_swkid_user['usr_short_name'];
		}elseif ($v_swkid_user['login_by'] == 'sarawaknet'){
			$v_cond['usr_short_name'] = $v_swkid_user['usr_ldap_sarawaknet_id'];
		}
		if (isset($v_cond['usr_short_name']) && !empty($v_cond['usr_short_name'])){
			$v_cond['_rec_status@NOT_IN'][0] = 'DELETED';
			$v_user = \E::get('obj_system_module')->user_get($v_cond);
			\E::set_session('usr_id',$v_user['usr_id']);
			if (isset($v_user) && is_array($v_user)){
				//== set session acl
				$this->set_acl();
				header("location:". MOONLIGHT_DNS_PATH . MOONLIGHT_FOLDER_PATH);
			}else{
				$_SESSION['message'] = \E::get('obj_curr_module_lang')->get('LOGIN_LDAP_ERROR');
				header("location:". MOONLIGHT_DNS_PATH . MOONLIGHT_FOLDER_PATH);
				exit();
			}
		}else{
			$_SESSION['message'] = \E::get('obj_curr_module_lang')->get('LOGIN_LDAP_ERROR');
			header("location:". MOONLIGHT_DNS_PATH . MOONLIGHT_FOLDER_PATH);
			exit();
		}
	}
	public function set_acl() {
		$v_all_data = "";
		$v_get_user = \E::get( 'obj_curr_module')->user_get_data(\E::get_session('usr_id'));
		if( isset($v_get_user) ) {
			if( $v_get_user != '' ) {
				if( isset($v_get_user[0]) ) {
					$v_all_data =$v_get_user[0];
				}
			}
		}
		if( isset($v_all_data['active_inactive_status']) ) {
			if( $v_all_data['active_inactive_status'] == 0 ) {
				\E::get( 'obj_system_module')->logout();
				header("location:". MOONLIGHT_DNS_PATH . MOONLIGHT_FOLDER_PATH);
				die();
			}
		}
		$v_user_acl_infor = \E::get('obj_curr_module')->user_acl_get(\E::get_session('usr_id'));
		if (is_array($v_user_acl_infor)) {
			$v_user_group_infor = \E::get('obj_curr_module')->user_group_get($v_user_acl_infor[0]['group_id']);
		}
		if (isset($v_user_group_infor) && is_array($v_user_group_infor) && is_array($v_user_group_infor[0])) {
			$v_session_acl['access'] = 1;
			foreach ($v_user_group_infor[0] as $v_key => $v_acl) {
				if (substr($v_key, 0, 5) == "group") {
					$v_session_acl[$v_key] = $v_acl;
				}
			}
		} else {
			$v_session_acl['access'] = 0;
		}
		\E::set_session($this->get_codename(), $v_session_acl);
		$v_location_admin = "no";
		if( trim($v_all_data['location']) != "" ) {
			$v_location_data = \E::get( 'obj_curr_module')->location_get_by_id($v_all_data['location']);
			if( isset($v_location_data) ) {
				if( $v_location_data != '' ) {
					if( count($v_location_data) > 0 ) {
						if( in_array(\E::get_session('usr_id'), explode(",",$v_location_data['location_administrators'])) ) {
							$v_location_admin = "yes";
						}
					}
				}
			}
		}
		\E::set_session( "is_location_admin_for_cancelation_receipts" , $v_location_admin );
		\E::set_session( "c_user_agency_id" , $v_all_data['agency'] );
		\E::set_session( "c_user_location_id" , $v_all_data['location'] );
		\E::set_session( "logged_in_user_role" , $v_all_data['role'] );
		\E::set_session( "location_administrator" , $v_all_data['location_administrator'] );
		$v_get_role_type = \E::get( 'obj_curr_module')->user_get_role_data($v_all_data['role']);
		if( isset($v_get_role_type) ) {
			if( $v_get_role_type != '' ) {
				if( isset($v_get_role_type[0]) ) {
					$v_role_type_data =$v_get_role_type[0];
				}
			}
		}
		\E::set_session( "logged_in_user_type" , $v_role_type_data['role_type'] );
		\E::set_session( "logged_in_user_roles_id" , $v_role_type_data['id'] );
	}
	public function get_codename() {
		return 'eticket';
	}
	public function auto_set_acl_group($p_info) {
		return TRUE;
	}
	public function user_add($p_usr_id, $p_array_param) {
	}
	public function user_remove($p_usr_id) {
	}
	public function user_change_name($p_usr_id, $p_usr_old_name, $p_usr_new_name) {
	}
	public function get_theme() {
		return \E::get('obj_kernel_config')->get('gui/theme');
	}
	public function get_theme_color() {
		return \E::get('obj_kernel_config')->get('gui/color');
	}
	public function is_able_to_access($p_usr_id, $p_usr_name) {
		// Login bypass on action level
		$v_bypass_login = array();
		// Sample bypass set for "forgot" action under "user" component
		$v_bypass_login[] = 'personal_account/index';
		$v_current_component_action = \E::get('MOONLIGHT_CURRENT_COMPONENT') . '/' . \E::get('MOONLIGHT_CURRENT_ACTION');
		if (in_array($v_current_component_action , $v_bypass_login)) {
		   return TRUE;
		}
		// Login bypass on component level
		$v_bypass_login_component = array();
		// Sample bypass set for "cronjob" component
		$v_bypass_login_component[] = 'cronjob';
		if (in_array(\E::get('MOONLIGHT_CURRENT_COMPONENT'), $v_bypass_login_component)) {
			return TRUE;
		}
		// determine access control
		if (\E::is_anonymous()) {
			return FALSE;
		} else {
			$this->c_usr_id = $p_usr_id;
			$this->c_usr_name = $p_usr_name;
			return TRUE;
		}
	}
	public function get_config() {
		return $this->co_config;
	}
	/*
	 * Check for access right for each component. Read, Add, Edit and Delete
	 * New added acl name. If not pass, will use current comp as default.
	 */
	public function get_right_to_access($p_action = 'read', $p_acl_name = NULL) {
		if (is_null($p_acl_name)) {
			$v_current_component = \E::get('MOONLIGHT_CURRENT_COMPONENT');
			$v_current_component_action = \E::get('MOONLIGHT_CURRENT_COMPONENT') . '/' . \E::get('MOONLIGHT_CURRENT_ACTION');
			//Build acl variable name in used in session
			$v_acl_var_postfix = str_replace(" ", "_", trim($v_current_component));
			$v_acl_var = "group_com_" . $v_acl_var_postfix;
		} else {
			$v_acl_var = "group_com_" . $p_acl_name;
		}
		//Get acl value stored in session
		unset($v_acl_val);
		$v_acl_val = \E::get_session($this->get_codename() . '/' . $v_acl_var);
		//Convert acl value into binary (4 digit binary)
		$v_tmp_val = substr("0000" . decbin($v_acl_val), -4);
		//Turn the binary code to array
		$v_acl_arr = str_split($v_tmp_val);
		//cell 0 = delete, 1 = edit, 2 = add, 3 = read
		switch (strtolower($p_action)) {
			case "read":
				$v_acl_check = $v_acl_arr[3];
				break;
			case "add":
				$v_acl_check = $v_acl_arr[2];
				break;
			case "edit":
				$v_acl_check = $v_acl_arr[1];
				break;
			case "delete":
				$v_acl_check = $v_acl_arr[0];
				break;
		}
		//if ($v_acl_check == 1) {
		if (true) {
			return TRUE;
		} else {
			return FALSE;
		}
	}
	public function get_component_acl_list() {
		$v_ignore_list = array("cronjob", "home", "share");
		return $this->get_component_list($v_ignore_list);
	}
	/**
	 * Get Component listing in current module.
	 *
	 * @access public
	 * @param string $p_array_ignore_comp Which folder to ignore.
	 * @return
	 */
	public function get_component_list($p_array_ignore_comp = NULL) {
		$v_path = MOONLIGHT_MODULE_PATH . \E::get('obj_curr_module')->get_component_folder();
		$v_array_components = \U::get_all_dirs_name($v_path);
		if (!empty($p_array_ignore_comp)) {
			foreach ($v_array_components as $compName) {
				if (!in_array($compName, $p_array_ignore_comp)) {
					$v_array_components_final[] = $compName;
				}
			}
		} else {
			$v_array_components_final = $v_array_components;
		}
		return $v_array_components_final;
	}
	public function paging_build($o_kernel_lang, $p_total_rows, $p_rows_per_page, $p_page_num, $p_js_function = '', $p_param = "", $p_align = "center", $p_display_total = 1, $p_display_label = 1) {
		if ($p_align == "") $p_align = "center";
		if (substr($p_param, 0, 1) == '?') {
			$p_param = "&" . substr($p_param, 1);
		}
		$active_icon = "NAV_ACT_";
		$inactive_icon = "NAV_INACT_";
		$max_pages = ceil($p_total_rows / $p_rows_per_page);
		$max_pages = ($max_pages == 0) ? 1 : $max_pages;
		$self = $_SERVER['REDIRECT_URL'];
		if ($p_js_function != '') $txt_box_link = $p_js_function . "(\"$self?page=\"+this.value+\"$p_param\")";
		else    $txt_box_link = "window.location=\"$self?page=\"+this.value+\"$p_param\"";
		$page_box = "<input class='mb-0' type=text name='p_page_num' value='$p_page_num' maxlength=5 size=1 style='padding:0px;width:40px;text-align:center' onBlur='javascript:if(isNaN(this.value)||this.value<1 || this.value>" . $max_pages . "){this.value=$p_page_num}else if (this.value!=\"$p_page_num\"){ $txt_box_link }'>";
		$page_n_of_x = str_replace('<n>', $page_box, $o_kernel_lang->get('PG_PAGE_N_OF_X'));
		$page_n_of_x = str_replace('<x>', '<b>' . $max_pages . '</b>', $page_n_of_x);
		$page_n_of_x = '<li">' . $page_n_of_x . '</li>';
		// FIRST and PREV link
		if ($p_page_num > 1) {
			// active link
			$page = $p_page_num - 1;
			$v_url = $self . '?page=' . $page . $p_param;
			if ($p_js_function != '') {
				$v_url = 'javascript:' . $p_js_function . '(\'' . $v_url . '\')';
			}
			$prev = '<li class="page-item">';
			$prev .= '<a class="page-link" href="' . $v_url . '" TITLE="' . $o_kernel_lang->get('PG_PREVIOUS_PAGE') . '">';
			$prev .= '<i class="fa fa-fw fa-angle-left"></i>';
			$prev .= ' ' . $o_kernel_lang->get('PG_PREVIOUS_PAGE');
			$prev .= '</a>';
			$prev .= '</li>';
			$prev .= chr(10);
			$v_url = $self . '?page=1' . $p_param;
			if ($p_js_function != '') {
				$v_url = 'javascript:' . $p_js_function . '(\'' . $v_url . '\')';
			}
			$first = '<li class="page-item">';
			$first .= '<a class="page-link" href="' . $v_url . '" TITLE="' . $o_kernel_lang->get('PG_FIRST_PAGE') . '">';
			$first .= '<i class="fa fa-fw fa-angle-double-left"></i>';
			$first .= " " . $o_kernel_lang->get('PG_FIRST_PAGE');
			$first .= "</a>";
			$first .= "</li>";
			$first .= chr(10);
		} else {
			// inactive link
			$prev = '<li class="page-item disabled"><span class="page-link">';
			$prev .= '<i class="fa fa-fw fa-angle-left"></i>';
			$prev .= " " . $o_kernel_lang->get('PG_PREVIOUS_PAGE');
			$prev .= "</span></li>";
			$prev .= chr(10);
			$first = '<li class="page-item disabled"><span class="page-link">';
			$first .= '<i class="fa fa-fw fa-angle-double-left"></i>';
			$first .= " " . $o_kernel_lang->get('PG_FIRST_PAGE');
			$first .= "</span></li>";
			$first .= chr(10);
		}
		// NEXT and LAST link
		if ($p_page_num < $max_pages) {
			// active link
			$page = $p_page_num + 1;
			$v_url = $self . '?page=' . $page . $p_param;
			if ($p_js_function != '') {
				$v_url = 'javascript:' . $p_js_function . '(\'' . $v_url . '\')';
			}
			$next = '<li class="page-item">';
			$next .= "<a href=\"$v_url\" TITLE=\"{$o_kernel_lang->get('PG_NEXT_PAGE')}\">";
			$next .= '<i class="fa fa-fw fa-angle-right"></i>';
			$next .= \R::get_image_tag($active_icon . 'NEXT');
			$next .= "</a>";
			$next .= "</li>";
			$next .= chr(10);
			$v_url = $self . '?page=' . $max_pages . $p_param;
			if ($p_js_function != '') {
				$v_url = 'javascript:' . $p_js_function . '(\'' . $v_url . '\')';
			}
			$last = '<li class="page-item">';
			$last .= "<a href=\"$v_url\" TITLE='{$o_kernel_lang->get('PG_LAST_PAGE')}'>";
			$last .= '<i class="fa fa-fw fa-angle-double-right"></i>';
			$last .= \R::get_image_tag($active_icon . 'LAST');
			$last .= "</a>";
			$last .= "</li>";
			$last .= chr(10);
		} else {
			// inactive link
			$next = '<li class="page-item disabled"><span class="page-link">';
			$next .= '<i class="fa fa-fw fa-angle-right"></i>';
			$next .= " " . $o_kernel_lang->get('PG_NEXT_PAGE');
			$next .= "</span></li>";
			$last = '<li class="page-item disabled"><span class="page-link">';
			$last .= '<i class="fa fa-fw fa-angle-double-right"></i>';
			$last .= " " . $o_kernel_lang->get('PG_LAST_PAGE');
			$last .= "</span></li>";
			$last .= chr(10);
		}
		$total_rec = ($p_display_total == 0) ? '' : '<li class="page-item disabled"><span class="page-link">' . $o_kernel_lang->get('PG_TOTAL_RECORDS') . $p_total_rows . '</span></li>';
		$v_page_html = '<ul class="pagination justify-content-center">';
		$v_page_html .= $first . $prev . $total_rec . $next . $last;
		$v_page_html .= '</ul>';
		$v_page_html .= chr(10) . chr(13);
		$v_page_html .= '<ul class="pagination justify-content-center">';
		$v_page_html .= $page_n_of_x;
		$v_page_html .= '</ul>';
		$v_page_html .= chr(10) . chr(13);
		return $v_page_html;
	}
	public function __call($name, $arguments) {
		$v_namespace = "\\" . __NAMESPACE__ . "\\"; /* Using namespace to allow duplicate modules in single project */
		$v_temp_arr = explode("_", $name);
		$v_temp_arr = array_reverse($v_temp_arr);
		$v_temp_name = array_pop($v_temp_arr);
		$v_temp_name = strtolower($v_temp_name);
		$v_module_code = \E::get('obj_curr_module')->get_config()->get('general/module_code');
		$v_cls_name_prefix = $v_namespace . $v_module_code . "_";
		// moonlight_autoload_class( $v_cls_name_prefix.$v_temp_name );
		$v_count = 0;  /* Set a limit to avoid endless loop */
		$v_continue = (class_exists($v_cls_name_prefix . $v_temp_name) && method_exists($v_cls_name_prefix . $v_temp_name, $name));
		while (!$v_continue) {
			$v_temp_val = array_pop($v_temp_arr);
			if (empty($v_temp_val)) { /* If is null mean last item in the array or not array, stop loop */
				break;
			}
			// moonlight_autoload_class( $v_cls_name_prefix.$v_temp_name );
			if (class_exists($v_cls_name_prefix . $v_temp_name) && method_exists($v_cls_name_prefix . $v_temp_name, $name)) {
				break;
			}
			$v_temp_name .= "_" . $v_temp_val;
			$v_temp_name = strtolower($v_temp_name);
			if (strtoupper($v_temp_name) == strtoupper($name)) { /* Stop the loop when the key is already same as the estimate class name */
				break;
			}
			$v_count++;
			if ($v_count > 5) {
				break;
			}
		}
		$v_call_obj = $v_cls_name_prefix . $v_temp_name;
		if (!isset($this->co_obj[$v_temp_name])) {
			$this->co_obj[$v_temp_name] = new $v_call_obj($this->co_db);
		}
		if (isset($this->co_obj[$v_temp_name])) {
			return call_user_func_array(array($this->co_obj[$v_temp_name], $name), $arguments);
		}
	}
	/**
	 * Retrieve agency, based on User LOGIN ID
	 *	
	 * @access public
	 * @return
	 */
	public function get_agency_condition($p_col_name) {
		$v_agency_condition = "";
		$v_user_type = \E::get_session( "logged_in_user_type");
		if( $v_user_type == 2 ) {
		} else {
			$v_c_user_agency_id = \E::get_session( "c_user_agency_id");
			if( isset($v_c_user_agency_id) && $v_c_user_agency_id != '' ) {
				$v_agency_condition = " AND " . \U::safe_sql_string($p_col_name) . "  = '" . \U::safe_sql_string($v_c_user_agency_id) . "'";
			}
		}
		return $v_agency_condition;
	}
	/**
	 * Retrieve Locations, based on User Login
	 *
	 * @access public
	 * @return
	 */
	public function get_location_condition($p_col_name,$p_specific_module=NULL) {
		$v_agency_condition = "";
		$v_user_type = \E::get_session( "logged_in_user_type");
		if( $v_user_type == 2 ) {
		} else {
			$v_c_user_agency_id = \E::get_session( "c_user_location_id");
			if( isset($v_c_user_agency_id) && $v_c_user_agency_id != '' ) {
				$v_check_location_administrator = 0;
				if( isset($p_specific_module) && $p_specific_module == 'buy_ticket' ) {
					$v_location_administrator = \E::get_session( "location_administrator");
					if( isset($v_location_administrator) && $v_location_administrator == '1' ) {
						$v_check_location_administrator = 1;
					}
				}
				if( $v_check_location_administrator == 0 ) {
					$v_agency_condition = " AND " . \U::safe_sql_string($p_col_name) . "  = '" . \U::safe_sql_string($v_c_user_agency_id) . "'";
				}
			}
		}
		return $v_agency_condition;
	}
}
?>