<?php
namespace moonlight\eticket;
class eticket_att_mysql {
	private $co_db_root;
	public function __call($name, $arguments){
		$v_tmp_arr = explode("_", $name);
		$v_call_obj = $v_tmp_arr[0];
		if(isset($this->co_db_root)){
			return call_user_func_array(array($this->co_db_root, $name), $arguments);
		}
	}
	public function __construct( &$p_co_db ){
		$this->co_db_root = $p_co_db;
	}
	/**
	 * Insert new attachment data in att table
	 *
	 * @access public
	 * @return
	 */
	public function att_add($p_data) {
		if( isset($p_data) ) {
			if( count($p_data) > 0 ) {
				$v_query = "INSERT INTO
						" . $this->get_db_table_prefix() . "att
					SET
						master_id = '".\U::safe_sql_string($p_data['master_id'])."',
						_rec_status = '".\U::safe_sql_string($p_data['_rec_status'])."',
						_rec_created_by = '".\U::safe_sql_string($p_data['_rec_created_by'])."',
						_rec_created_on = '".\U::safe_sql_string($p_data['_rec_created_on'])."',
						_rec_modified_by = '".\U::safe_sql_string($p_data['_rec_modified_by'])."',
						_rec_modified_on = '".\U::safe_sql_string($p_data['_rec_modified_on'])."'
					";
				$v_add = $this->co_db_root->execute_query($v_query);
				if ($v_add) {
					return $v_add_id = $this->co_db_root->get_last_insert_id();
				}
			}
		}
	}
	/**
	 * Update attachment data in att table to add sftp_par_id
	 *
	 * @access public
	 * @return
	 */
	public function att_edit($p_data, $p_id_to_update_table) {
		if( isset($p_data) ) {
			if( count($p_data) > 0 ) {
				if( isset($p_id_to_update_table) && $p_id_to_update_table != '' ) {
					$v_query = "UPDATE
							" . $this->get_db_table_prefix() . "att
						SET
							sftp_par_id = '".\U::safe_sql_string($p_data['sftp_par_id'])."',
							_rec_modified_by = '".\U::safe_sql_string($p_data['_rec_modified_by'])."',
							_rec_modified_on = '".\U::safe_sql_string($p_data['_rec_modified_on'])."'
						WHERE
							att_id = '".\U::safe_sql_string($p_id_to_update_table)."'
						";
					$v_update = $this->co_db_root->execute_query($v_query);
					if ($v_update) {
						return TRUE;
					}
				}
			}
		}
	}
	/**
	 * Get attachment data from att table by id
	 *
	 * @access public
	 * @return
	 */
	public function att_get_by_id($p_att_tbl_master_id) {
		if( isset($p_att_tbl_master_id) ) {
			$v_query = "SELECT
							*
				 		FROM 
				 			" . $this->get_db_table_prefix() . "att 
				 		WHERE
				 			master_id = '".\U::safe_sql_string($p_att_tbl_master_id)."'
				 		AND 
			 				_rec_status = \"SHOW\"
				 ";
			$v_att_data = $this->co_db_root->execute_query($v_query);
			if( isset($v_att_data) ) {
				if( $v_att_data != '' ) {
					return $v_att_data[0];
				}
			}
		}
	}
}
?>