<?PHP
$v_access_add = \E::get('obj_curr_module')->ajax_validation_check_permission("add");
if( !$v_access_add ){
    \V::append_data( 'body', \V::load_box( \E::get( 'obj_curr_module_lang')->get('MODULE_AUTHORISED_ERROR'), \V::load_view( $this->get_view_file_path( 'msg_not_authorised', 'share' ), $v_object, $v_var ), 'box_form.php' ) );
    \V::output_view( 'template_login.php' );
    exit;
}
$v_param = $this->get_param();
$v_tmp_list = \E::get('obj_curr_module')->user_group_list();
$v_group_list['no_access'] = "[No Access]";
if (is_array($v_tmp_list)) {
	for ($v_c = 0; $v_c < count($v_tmp_list); $v_c++) {
		$v_group_list[$v_tmp_list[$v_c]['group_id']] = $v_tmp_list[$v_c]['group_name'];
	}
}
$v_user_roles = \E::get('obj_curr_module')->user_group_list();
$v_agency_dta = \E::get('obj_curr_module')->user_group_agency_lit();
$v_location_data = \E::get('obj_curr_module')->user_group_location_list();
if ($_SERVER['REQUEST_METHOD'] == 'POST') {
	foreach ($_POST as $v_key => $v_value) {
		$_POST[$v_key] = trim($v_value);
	}
	
	\I::check("COMPULSORY", 'location_code', \E::get("obj_kernel_lang")->get('ERR_JS_FIELD_REQUIRED'));
	\I::check("COMPULSORY", 'location_name', \E::get("obj_kernel_lang")->get('ERR_JS_FIELD_REQUIRED'));
	\I::check("COMPULSORY", 'contact_no', \E::get("obj_kernel_lang")->get('ERR_JS_FIELD_REQUIRED'));
	\I::check("COMPULSORY", 'email', \E::get("obj_kernel_lang")->get('ERR_JS_FIELD_REQUIRED'));
	\I::check("EMAIL", 'email', \E::get("obj_kernel_lang")->get('ERR_JS_INVALID_EMAIL'));
	\I::check("COMPULSORY", 'address', \E::get("obj_kernel_lang")->get('ERR_JS_FIELD_REQUIRED'));
	\I::check("COMPULSORY", 'post_code', \E::get("obj_kernel_lang")->get('ERR_JS_FIELD_REQUIRED'));
	\I::check("COMPULSORY", 'division', \E::get("obj_kernel_lang")->get('ERR_JS_FIELD_REQUIRED'));

	$sarawak_pay_merchant = "";
	if (isset($_POST['sarawak_pay_merchant'])) {
		$sarawak_pay_merchant = $_POST['sarawak_pay_merchant'];
		if ($_POST['sarawak_pay_merchant'] == "yes") {

			\I::check("COMPULSORY", 'merchant_id', \E::get("obj_kernel_lang")->get('ERR_JS_FIELD_REQUIRED'));
			\I::check("COMPULSORY", 'merchant_private_key', \E::get("obj_kernel_lang")->get('ERR_JS_FIELD_REQUIRED'));

		} else if ($_POST['sarawak_pay_merchant'] == "no") {
			$_POST['merchant_id'] = "";
			$_POST['merchant_private_key'] = "";
		}
	}

	if (isset($_POST['sarawak_pay_sifbas'])) {
		$v_sarawak_pay_sifbas = $_POST['sarawak_pay_sifbas'];
		if ($_POST['sarawak_pay_sifbas'] == "yes") {
			\I::check("COMPULSORY", 'ptj_code', \E::get("obj_kernel_lang")->get('ERR_JS_FIELD_REQUIRED'));
		} else if ($_POST['sarawak_pay_sifbas'] == "no") { 
			$_POST['ptj_code'] = "";
		}
	}
	
	$v_field_name = "code";
	$v_table_name = "locations";
	$v_field_value = $_POST['location_code'];
	$v_check_info = \E::get('obj_curr_module')->user_check_duplicate_field($v_field_name, $v_field_value, $v_table_name);
	if ($v_check_info && is_array($v_check_info)) {
		\I::set_error_field('location_code', \E::get('obj_curr_module_lang')->get('LOCATION_ALREADY_EXISTS') );
	}
	if (!\I::is_error()) {
		$v_add['code'] = $_POST['location_code'];
		$v_add['name'] = $_POST['location_name'];
		$v_add['agency_id'] = $_POST['ticket_profile_agency_name'];
		$v_add['contact_no'] = $_POST['contact_no'];
		$v_add['fax'] = $_POST['fax'];
		$v_add['email'] = $_POST['email'];
		$v_add['address'] = $_POST['address'];
		$v_add['post_code'] = $_POST['post_code'];
		$v_add['division'] = $_POST['division'];
		$v_add['person_charge'] = $_POST['person_charge'];
		$v_add['total_ticket_per_day'] = $_POST['total_ticket_per_day'];
		$v_add['sarawak_pay_merchant'] = $sarawak_pay_merchant;
		$v_add['sarawak_pay_sifbas'] = $v_sarawak_pay_sifbas;
		$v_add['merchant_id'] = $_POST['merchant_id'];
		$v_add['merchant_private_key'] = $_POST['merchant_private_key'];
		$v_add['ptj_code'] = $_POST['ptj_code'];
		$v_add['remarks'] = $_POST['remarks'];
		$v_logged_in_user_id = \E::get_session('usr_id');
		$v_str_now = date("Y-m-d H:i:s");
		$v_add['_rec_status'] = 'SHOW';
		$v_add['_rec_created_by'] = $v_logged_in_user_id;
		$v_add['_rec_created_on'] = $v_str_now;
		$v_add['_rec_modified_by'] = $v_logged_in_user_id;
		$v_add['_rec_modified_on'] = $v_str_now;
		$v_locations_add = \E::get('obj_curr_module')->agency_save($v_add);
		$v_add['usr_id'] = $v_locations_add;
		if (isset($v_locations_add) && $v_locations_add !== FALSE) {
			if (isset($_FILES['doc_file']) && !empty($_FILES['doc_file']) && !empty($_FILES['doc_file']['name'])){
				$v_loc_img_prefix = \E::get('obj_curr_module')->location_get_code_table_data_on_key_name("agency_img_prefix");
				$v_att['master_id'] = $v_loc_img_prefix['key_value'].$v_locations_add;
				$v_logged_in_user_id = \E::get_session('usr_id');
				$v_str_now = date("Y-m-d H:i:s");
				$v_att['_rec_status'] = 'SHOW';
				$v_att['_rec_created_by'] = $v_logged_in_user_id;
				$v_att['_rec_created_on'] = $v_str_now;
				$v_att['_rec_modified_by'] = $v_logged_in_user_id;
				$v_att['_rec_modified_on'] = $v_str_now;
				$v_att_id = \E::get('obj_curr_module')->att_add($v_att);
				unset($v_att);
				$v_table_info['tbl_id'] = $v_att_id;
				$v_table_info['tbl_name'] = "t_eticket_att";
				$v_table_info['_rec_created_by'] = \E::get_session('usr_id');
				$v_obj_setting ['obj'] = \E::get('obj_curr_module');
				$v_att_info = \A::attachment_upload($v_obj_setting, $_FILES['doc_file'], $v_table_info);
				$v_att['sftp_par_id'] = $v_att_info['id'];
				$v_att['_rec_modified_by'] = $v_logged_in_user_id;
				$v_att['_rec_modified_on'] = $v_str_now;
				\E::get('obj_curr_module')->att_edit($v_att,$v_att_id);
				unset($v_att);
			}
			$log_status = \E::get('obj_curr_module')->user_group_add_logs_data($v_add, "Add", "Agency Profile", NULL);
			\E::set_session(\E::get('MOONLIGHT_CURRENT_COMPONENT') . '-message-title', \E::get('obj_curr_module_lang')->get('SUCCESS'));
			\E::set_session(\E::get('MOONLIGHT_CURRENT_COMPONENT') . '-message', \E::get('obj_curr_module_lang')->get('RECORD_ADDED'));
			\E::set_session(\E::get('MOONLIGHT_CURRENT_COMPONENT') . '-message-status', 'success');
		} else {
			\E::set_session(\E::get('MOONLIGHT_CURRENT_COMPONENT') . '-message-title', \E::get('obj_curr_module_lang')->get('FAILED'));
			\E::set_session(\E::get('MOONLIGHT_CURRENT_COMPONENT') . '-message', \E::get('obj_curr_module_lang')->get('FAILED_TO_ADD_RECORD'));
			\E::set_session(\E::get('MOONLIGHT_CURRENT_COMPONENT') . '-message-status', 'error');
		}
		header('location: ' . \E::get('obj_curr_module')->build_action_path('agency', 'edit', $v_locations_add));
		exit();
	}
	foreach ($_POST as $v_key => $v_value) {
		$v_var[$v_key] = trim($v_value);
	}
}
$v_var['today_date'] = \E::get('obj_curr_module')->__to_display_date(\E::get('obj_curr_module')->__now(), 'DATE');
$v_var['mode'] = 'add';
$v_var['group_list'] = $v_group_list;
$v_var['user_roles'] = $v_user_roles;

$v_ecs_v1_0pdf = \E::get('obj_curr_module')->buy_ticket_get_code_table_vallue_by_key_name("ecs_v1_0pdf");
$v_encryption_decryption_v1_0pdf = \E::get('obj_curr_module')->buy_ticket_get_code_table_vallue_by_key_name("encryption_decryption_v1_0pdf");
$v_var['ecs_v1_0pdf'] = $v_ecs_v1_0pdf['key_value'];
$v_var['encryption_decryption_v1_0pdf'] = $v_encryption_decryption_v1_0pdf['key_value'];

$v_var['agency_dta'] = $v_agency_dta;
$v_var['location_data'] = $v_location_data;
\V::append_data('js', \V::load_view(MODULE_PLUGIN_PATH . 'sweetalert2/moonlight_init.php', $v_object, $v_var));
\V::append_data('menu', \V::load_view($this->get_view_file_path('menu', 'share'), $v_object, $v_var));
\V::append_data('body', \V::load_view($this->get_view_file_path('form'), $v_object, $v_var));
\V::output_view();
?>