<?php
$v_access_view = \E::get('obj_curr_module')->ajax_validation_check_permission("view");
if( !$v_access_view ){
	\V::append_data( 'body', \V::load_box( \E::get( 'obj_curr_module_lang')->get('MODULE_AUTHORISED_ERROR'), \V::load_view( $this->get_view_file_path( 'msg_not_authorised', 'share' ), $v_object, $v_var ), 'box_form.php' ) );
	\V::output_view( 'template_login.php' );
	exit;
}
define( 'SP_PUBLIC_KEY',        __DIR__."/key/sarawakpay_public_key.pub");
define( 'MERCHANT_PUBLIC_KEY', 	__DIR__."/key/merchant_public_key.pub");
define( 'MERCHANT_PRIVATE_KEY', __DIR__."/key/merchant_private_key.pem");
require_once('Encryption.php');
if (isset($_POST['v_save_ticket']) && $_POST['v_save_ticket'] === 'save') {
	if( isset($_POST['selected_quantity_list']) ) {
		if( count($_POST['selected_quantity_list']) > 0 ) {
			$response = \E::get('obj_curr_module')->buy_ticket_check_number_of_tickets_allowed($_POST);
			$limit_reached = $response['limit_reached'];
			$v_location_per_day_limit = $response['v_location_per_day_limit'];
			$v_used_tickets = $response['v_used_tickets'];
			$v_total_qty_added = $response['v_total_qty_added'];
			if( $limit_reached == 1 ) {
				$v_remaining_tickets = ($v_location_per_day_limit-$v_used_tickets);
				if( $v_remaining_tickets == 0 ) {
					$v_message = \E::get('obj_curr_module_lang')->get('BUY_TICKET_LIMIT_REACHED_PER_DAY').$v_location_per_day_limit.\E::get('obj_curr_module_lang')->get('BUY_TICKET_LIMIT_REACHED_USED').$v_used_tickets.\E::get('obj_curr_module_lang')->get('BUY_TICKET_LIMIT_REACHED_CANNOT_PROCEED');
				} else {
					$v_message = \E::get('obj_curr_module_lang')->get('BUY_TICKET_LIMIT_REACHED_PER_DAY').$v_location_per_day_limit.\E::get('obj_curr_module_lang')->get('BUY_TICKET_LIMIT_REACHED_USED').$v_used_tickets.\E::get('obj_curr_module_lang')->get('BUY_TICKET_LIMIT_REACHED_NOW_PROCEED_WITH').$v_remaining_tickets.\E::get('obj_curr_module_lang')->get('BUY_TICKET_LIMIT_REACHED_MORE_TICKETS_ONLY').$v_total_qty_added.\E::get('obj_curr_module_lang')->get('BUY_TICKET_LIMIT_REACHED_ONLY_STRONG_TAG');
				}
				echo "limit_reached==".$v_message.".";
				die();
			}
		}
	}
}
function checkNumberOfTicketsAllowed($_post_data) {
	$respnose = array();
	$limit_reached = 0;
	$v_used_tickets = 0;
	$v_total_qty_added = 0;
	$v_location_per_day_limit = 0;
	foreach ($_post_data['selected_quantity_list'] as $v_key => $v_each_profile_data) {
		 $v_total_qty_added += $v_each_profile_data['quantity'];
	}
	$v_select_location = $_post_data['select_location'];
	$v_location_per_day = \E::get('obj_curr_module')->ajax_validation_get_location_per_day($v_select_location);
	$v_location_per_day_used = \E::get('obj_curr_module')->ajax_validation_get_location_per_day_used($v_select_location);
	if( isset($v_location_per_day[0]['total_ticket_per_day']) && $v_location_per_day[0]['total_ticket_per_day'] != '' ) {
		$v_location_per_day_limit = $v_location_per_day[0]['total_ticket_per_day'];
	}
	$v_location_per_day_limit_used = $v_total_qty_added;
	if( isset($v_location_per_day_used[0]['total_per_day_ticket_used']) && $v_location_per_day_used[0]['total_per_day_ticket_used'] != '' ) {
		$v_used_tickets = $v_location_per_day_used[0]['total_per_day_ticket_used'];
		$v_location_per_day_limit_used += $v_location_per_day_used[0]['total_per_day_ticket_used'];
	}
	if( ($v_location_per_day_limit == 0) || ($v_location_per_day_limit < $v_location_per_day_limit_used) ) {
		$limit_reached = 1;
	}
	$respnose["limit_reached"] = $limit_reached;
	$respnose["v_used_tickets"] = $v_used_tickets;
	$respnose["v_total_qty_added"] = $v_total_qty_added;
	$respnose["v_location_per_day_limit"] = $v_location_per_day_limit;
	return $respnose;
}
?>