<?php
$v_access_user = \E::get('obj_curr_module')->ajax_validation_check_permission("view", "user");
$v_access_user_role = \E::get('obj_curr_module')->ajax_validation_check_permission("view", "user_role");
$v_access_agency = \E::get('obj_curr_module')->ajax_validation_check_permission("view", "agency");
$v_access_location = \E::get('obj_curr_module')->ajax_validation_check_permission("view", "location");
$v_access_ticket_category = \E::get('obj_curr_module')->ajax_validation_check_permission("view", "ticket_category");
$v_access_ticket_profile = \E::get('obj_curr_module')->ajax_validation_check_permission("view", "ticket_profile");
$v_access_ticket_template = \E::get('obj_curr_module')->ajax_validation_check_permission("view", "ticket_template");
$v_access_ticket_matrix = \E::get('obj_curr_module')->ajax_validation_check_permission("view", "ticket_overview_chart");
?>
	<div class="content-header pl-0 pb-0 pt-0 mx-n3 px-0">
		<div class="container-fluid">
			<div class="row mb-2">
				<div class="col-sm-12 breadcrumb_container">
					<a href="<?php echo \E::get('obj_curr_module')->build_action_path('home', 'index'); ?>">
						<?php echo \E::get('obj_curr_module_lang')->get('SYSTEM_ADMINISTRATOR_BREADCRUMB_HOME'); ?>
					</a> /
					<?php echo \E::get('obj_curr_module_lang')->get('SYSTEM_ADMINISTRATOR_BREADCRUMB_SETUP_CONFIGURATION'); ?>
				</div>
				<div class="col-sm-6 pl-3 pt-3">
					<h5 class="m-0 pb-0 module_name">
						<?php
						if ($v_controller_name == "list") {
							echo \E::get('obj_curr_module_lang')->get('SYSTEM_ADMINISTRATOR_CONFIGURE');
						}
						?>
					</h5>
				</div>
			</div>
		</div>
	</div>
	<hr/>
	<div class="table-responsive">
		<table class="table table-striped table-bordered">
			<thead>
			<tr>
				<th scope="col"><?php echo \E::get('obj_curr_module_lang')->get('SYSTEM_ADMINISTRATOR_NO'); ?></th>
				<th scope="col"><?php echo \E::get('obj_curr_module_lang')->get('SYSTEM_ADMINISTRATOR_FUNCTION'); ?></th>
			</tr>
			</thead>
			<tbody>
			<?php
			$v_module_counter = 0;
			if ($v_access_user == 1) { ?>
				<tr>
					<td scope="row"><?php echo ++$v_module_counter . "."; ?></td>
					<td>
						<h5><a href="<?php echo \E::get('obj_curr_module')->build_action_path('user', 'list'); ?>">
								<?php echo \E::get('obj_curr_module_lang')->get('SYSTEM_ADMINISTRATOR_USER_PROFILE'); ?>
							</a></h5>
					</td>
				</tr>
				<?php
			}
			if ($v_access_user_role == 1) { ?>
				<tr>
					<td scope="row"><?php echo ++$v_module_counter . "."; ?></td>
					<td>
						<h5><a href="<?php echo \E::get('obj_curr_module')->build_action_path('user_role', 'list'); ?>">
								<?php echo \E::get('obj_curr_module_lang')->get('SYSTEM_ADMINISTRATOR_USER_ROLE'); ?>
							</a></h5>
					</td>
				</tr>
				<?php
			}
			if ($v_access_agency == 1) { ?>
				<tr>
					<td scope="row"><?php echo ++$v_module_counter . "."; ?></td>
					<td>
						<h5><a href="<?php echo \E::get('obj_curr_module')->build_action_path('agency', 'list'); ?>">
								<?php echo \E::get('obj_curr_module_lang')->get('SYSTEM_ADMINISTRATOR_AGENCY_PROFILE'); ?>
							</a></h5>
					</td>
				</tr>
				<?php
			}
			if ($v_access_location == 1) { ?>
				<tr>
					<td scope="row"><?php echo ++$v_module_counter . "."; ?></td>
					<td>
						<h5><a href="<?php echo \E::get('obj_curr_module')->build_action_path('location', 'list'); ?>">
								<?php echo \E::get('obj_curr_module_lang')->get('SYSTEM_ADMINISTRATOR_LOCATION_PROFILE'); ?>
							</a></h5>
					</td>
				</tr>
				<?php
			}
			if ($v_access_ticket_category == 1) { ?>
				<tr>
					<td scope="row"><?php echo ++$v_module_counter . "."; ?></td>
					<td>
						<h5>
							<a href="<?php echo \E::get('obj_curr_module')->build_action_path('ticket_category', 'list'); ?>">
								<?php echo \E::get('obj_curr_module_lang')->get('SYSTEM_ADMINISTRATOR_TICKET_CATEGORY'); ?>
							</a></h5>
					</td>
				</tr>
				<?php
			}
			if ($v_access_ticket_profile == 1) { ?>
				<tr>
					<td scope="row"><?php echo ++$v_module_counter . "."; ?></td>
					<td>
						<h5>
							<a href="<?php echo \E::get('obj_curr_module')->build_action_path('ticket_profile', 'list'); ?>">
								<?php echo \E::get('obj_curr_module_lang')->get('SYSTEM_ADMINISTRATOR_TICKET_PROFILE'); ?>
							</a></h5>
					</td>
				</tr>
				<?php
			}
			if ($v_access_ticket_template == 1) { ?>
				<tr>
					<td scope="row"><?php echo ++$v_module_counter . "."; ?></td>
					<td>
						<h5>
							<a href="<?php echo \E::get('obj_curr_module')->build_action_path('ticket_template', 'list'); ?>">
								<?php echo \E::get('obj_curr_module_lang')->get('SYSTEM_ADMINISTRATOR_TICKET_TEMPLATE'); ?>
							</a></h5>
					</td>
				</tr>
				<?php
			}
			if ($v_access_ticket_matrix == 1) { ?>
				<tr>
					<td scope="row"><?php echo ++$v_module_counter . "."; ?></td>
					<td>
						<h5>
							<a href="<?php echo \E::get('obj_curr_module')->build_action_path('ticket_overview_chart', 'list'); ?>">
								<?php echo \E::get('obj_curr_module_lang')->get('SYSTEM_ADMINISTRATOR_TICKET_OVERVIEW_CHART'); ?>
							</a></h5>
					</td>
				</tr>
				<?php
			} ?>
			</tbody>
		</table>
	</div>
<?PHP
\I::load_error();
?>