<?PHP
$v_access_view = \E::get('obj_curr_module')->ajax_validation_check_permission("view");
if( !$v_access_view ){
	\V::append_data( 'body', \V::load_box( \E::get( 'obj_curr_module_lang')->get('MODULE_AUTHORISED_ERROR'), \V::load_view( $this->get_view_file_path( 'msg_not_authorised', 'share' ), $v_object, $v_var ), 'box_form.php' ) );
	\V::output_view( 'template_login.php' );
	exit;
}
$v_param = $this->get_param();
$v_id = $v_param[0];
$v_cond['usr_id'] = $v_id;
$v_location_data = \E::get('obj_curr_module')->agency_get_by_id($v_id);
$v_user_list_info_count = \E::get('obj_curr_module')->user_role_list_against_agencies("", "", "", "", "", $v_id);
$v_agency_useres_checking = 0;
if ($v_user_list_info_count && $v_user_list_info_count != "") {
	$v_agency_useres_checking = count($v_user_list_info_count);
}
$v_user_info = \E::get('obj_curr_module')->user_role_get($v_id);
$v_cond['usr_id'] = $v_user_info['roles_data'][0]['_rec_modified_by'];
$v_user_info_data = \E::get('obj_system_module')->user_get($v_cond);
$v_user_permissions = $v_user_info['roles_permissions'];
$v_user_info = $v_user_info['roles_data'][0];
if ($_SERVER['REQUEST_METHOD'] == 'POST') {
	foreach ($_POST as $v_key => $v_value) {
		$_POST[$v_key] = trim($v_value);
	}
	\I::check("COMPULSORY", 'location_code', \E::get("obj_kernel_lang")->get('ERR_JS_FIELD_REQUIRED'));
	\I::check("COMPULSORY", 'location_name', \E::get("obj_kernel_lang")->get('ERR_JS_FIELD_REQUIRED'));
	\I::check("COMPULSORY", 'contact_no', \E::get("obj_kernel_lang")->get('ERR_JS_FIELD_REQUIRED'));
	\I::check("COMPULSORY", 'email', \E::get("obj_kernel_lang")->get('ERR_JS_FIELD_REQUIRED'));
	\I::check("EMAIL", 'email', \E::get("obj_kernel_lang")->get('ERR_JS_INVALID_EMAIL'));
	\I::check("COMPULSORY", 'address', \E::get("obj_kernel_lang")->get('ERR_JS_FIELD_REQUIRED'));
	\I::check("COMPULSORY", 'post_code', \E::get("obj_kernel_lang")->get('ERR_JS_FIELD_REQUIRED'));
	\I::check("COMPULSORY", 'division', \E::get("obj_kernel_lang")->get('ERR_JS_FIELD_REQUIRED'));
	$v_sarawak_pay_merchant = "";
	if (isset($_POST['sarawak_pay_merchant'])) {
		$v_sarawak_pay_merchant = $_POST['sarawak_pay_merchant'];
		if ($_POST['sarawak_pay_merchant'] == "yes") {
			\I::check("COMPULSORY", 'merchant_id', \E::get("obj_kernel_lang")->get('ERR_JS_FIELD_REQUIRED'));
			\I::check("COMPULSORY", 'merchant_private_key', \E::get("obj_kernel_lang")->get('ERR_JS_FIELD_REQUIRED'));
		} else if ($_POST['sarawak_pay_merchant'] == "no") { 
			$_POST['merchant_id'] = "";
			$_POST['merchant_private_key'] = "";
		}
	}

	if (isset($_POST['sarawak_pay_sifbas'])) {
		$v_sarawak_pay_sifbas = $_POST['sarawak_pay_sifbas'];
		if ($_POST['sarawak_pay_sifbas'] == "yes") {
			\I::check("COMPULSORY", 'ptj_code', \E::get("obj_kernel_lang")->get('ERR_JS_FIELD_REQUIRED'));
		} else if ($_POST['sarawak_pay_sifbas'] == "no") { 
			$_POST['ptj_code'] = "";
		}
	}

	$v_field_name = "ag_code";
	$v_table_name = "agency";
	$v_field_value = $_POST['location_code'];
	$v_check_info = \E::get('obj_curr_module')->user_check_duplicate_field_edit($v_field_name, $v_field_value, $v_table_name, $v_id, "ag_id");
	if ($v_check_info && is_array($v_check_info)) {
		\I::set_error_field('location_code', \E::get('obj_curr_module_lang')->get('AGENCY_ALREADY_EXISTS'));
	}
	$v_update['code'] = $_POST['location_code'];
	$v_update['name'] = $_POST['location_name'];
	$v_update['agency_id'] = $_POST['agency_id'];
	$v_update['contact_no'] = $_POST['contact_no'];
	$v_update['fax'] = $_POST['fax'];
	$v_update['email'] = $_POST['email'];
	$v_update['address'] = $_POST['address'];
	$v_update['post_code'] = $_POST['post_code'];
	$v_update['division'] = $_POST['division'];
	$v_update['person_charge'] = $_POST['person_charge'];
	$v_update['total_ticket_per_day'] = $_POST['total_ticket_per_day'];
	$v_update['sarawak_pay_merchant'] = $v_sarawak_pay_merchant;
	$v_update['sarawak_pay_sifbas'] = $v_sarawak_pay_sifbas;
	$v_update['merchant_id'] = $_POST['merchant_id'];
	

	if(isset($_POST['merchant_private_key']) && $_POST['merchant_private_key'] != '') {
		$find = '********************************************************************************************************************************************************';
		if (strpos($_POST['merchant_private_key'], $find) !== false) {
			$v_update['merchant_private_key'] = $_POST['original_merchant_private_key'];
		} else {
			$v_update['merchant_private_key'] = $_POST['merchant_private_key'];
		}
	} else {
		$v_update['merchant_private_key'] = "";
	}
	

	$v_update['ptj_code'] = $_POST['ptj_code'];
	$v_update['remarks'] = $_POST['remarks'];
	$v_logged_in_user_id = \E::get_session('usr_id');
	$v_str_now = date("Y-m-d H:i:s");
	$v_update['_rec_status'] = 'SHOW';
	$v_update['_rec_modified_by'] = $v_logged_in_user_id;
	$v_update['_rec_modified_on'] = $v_str_now;
	if (!\I::is_error()) {
		$v_locations_update = \E::get('obj_curr_module')->agency_update($v_update, $v_id);
		if ($v_locations_update) {
			if (isset($_FILES['doc_file']) && !empty($_FILES['doc_file']) && !empty($_FILES['doc_file']['name'])){
				$v_agn_img_prefix = \E::get('obj_curr_module')->location_get_code_table_data_on_key_name("agency_img_prefix");
				$v_att_master_id = $v_agn_img_prefix['key_value'].$v_id;
				$v_att_id = \E::get('obj_curr_module')->att_get_by_id($v_att_master_id);
				if (isset($v_att_id['att_id']) && !empty($v_att_id['att_id'])) {
					$v_table_info['tbl_id'] = $v_att_master_id;
					$v_table_info['tbl_name'] = "t_eticket_att";
					$v_table_info['_rec_created_by'] = \E::get_session('usr_id');
					$v_obj_setting ['obj'] = \E::get('obj_curr_module');
					$v_att_info = \A::attachment_upload($v_obj_setting, $_FILES['doc_file'], $v_table_info);
					$v_att['sftp_par_id'] = $v_att_info['id'];
					$v_att['_rec_modified_by'] = $v_logged_in_user_id;
					$v_att['_rec_modified_on'] = $v_str_now;
					\E::get('obj_curr_module')->att_edit($v_att, $v_att_id['att_id']);
					unset($v_att);
				}else{
					$v_att['master_id'] = $v_agn_img_prefix['key_value'].$v_id;
					$v_logged_in_user_id = \E::get_session('usr_id');
					$v_str_now = date("Y-m-d H:i:s");
					$v_att['_rec_status'] = 'SHOW';
					$v_att['_rec_created_by'] = $v_logged_in_user_id;
					$v_att['_rec_created_on'] = $v_str_now;
					$v_att['_rec_modified_by'] = $v_logged_in_user_id;
					$v_att['_rec_modified_on'] = $v_str_now;
					$v_att_id = \E::get('obj_curr_module')->att_add($v_att);
					unset($v_att);
					$v_table_info['tbl_id'] = $v_att_id;
					$v_table_info['tbl_name'] = "t_eticket_att";
					$v_table_info['_rec_created_by'] = \E::get_session('usr_id');
					$v_obj_setting ['obj'] = \E::get('obj_curr_module');
					$v_att_info = \A::attachment_upload($v_obj_setting, $_FILES['doc_file'], $v_table_info);
					$v_att['sftp_par_id'] = $v_att_info['id'];
					$v_att['_rec_modified_by'] = $v_logged_in_user_id;
					$v_att['_rec_modified_on'] = $v_str_now;
					\E::get('obj_curr_module')->att_edit($v_att,$v_att_id);
					unset($v_att);
				}
			}
			$v_log_status = \E::get('obj_curr_module')->user_group_add_logs_data($v_update, "Update", "Agency Profile", $_POST['old_value']);
			\E::set_session(\E::get('MOONLIGHT_CURRENT_COMPONENT') . '-message-title', \E::get('obj_curr_module_lang')->get('SUCCESS'));
			\E::set_session(\E::get('MOONLIGHT_CURRENT_COMPONENT') . '-message', \E::get('obj_curr_module_lang')->get('RECORD_UPDATED'));
			\E::set_session(\E::get('MOONLIGHT_CURRENT_COMPONENT') . '-message-status', 'success');
		}
		header('location: ' . \E::get('obj_curr_module')->build_action_path('agency', 'edit', $v_id));
		exit();
	}
	foreach ($_POST as $v_key => $v_value) {
		$v_var[$v_key] = trim($v_value);
	}
}
$v_agn_img_prefix = \E::get('obj_curr_module')->location_get_code_table_data_on_key_name("agency_img_prefix");
$v_obj_setting['obj'] = \E::get('obj_curr_module');
$v_att_master_id = $v_agn_img_prefix['key_value'].$v_id;
$v_att_id = \E::get('obj_curr_module')->att_get_by_id($v_att_master_id);
$v_file_id = $v_att_id['sftp_par_id'];
$v_var['att_master_id'] = $v_att_master_id;
if (isset($v_file_id)) {
	$v_doc = \A::attachment_get($v_obj_setting, $v_file_id, TRUE, TRUE);
	$v_image_data = file_get_contents($v_doc['tmp_name']); // path to file like /var/tmp/...
	$v_var['image_data'] = $v_image_data;
	$v_var['image_data_path'] = $v_doc['tmp_name'];
}

$v_ecs_v1_0pdf = \E::get('obj_curr_module')->buy_ticket_get_code_table_vallue_by_key_name("ecs_v1_0pdf");
$v_encryption_decryption_v1_0pdf = \E::get('obj_curr_module')->buy_ticket_get_code_table_vallue_by_key_name("encryption_decryption_v1_0pdf");
$v_var['ecs_v1_0pdf'] = $v_ecs_v1_0pdf['key_value'];
$v_var['encryption_decryption_v1_0pdf'] = $v_encryption_decryption_v1_0pdf['key_value'];

$v_var['id'] = $v_id;
$v_cond['usr_id'] = $v_location_data['_rec_modified_by'];
$v_user_info_data = \E::get('obj_system_module')->user_get($v_cond);
$v_var['re_modified_by'] = $v_user_info_data['usr_full_name'];
$v_var['re_modified_date'] = $v_location_data['_rec_modified_on'];
$v_agency_dta = \E::get('obj_curr_module')->user_group_agency_lit();
$v_var['view_data'] = $v_location_data;
$v_var['agency_dta'] = $v_agency_dta;
$v_var['controller_name'] = "edit";
$v_var['agency_useres_checking'] = $v_agency_useres_checking;
\V::append_data('js', \V::load_view(MODULE_PLUGIN_PATH . 'datatables/moonlight_init.php', $v_object, $v_var));
\V::append_data('js', \V::load_view(MODULE_PLUGIN_PATH . 'sweetalert2/moonlight_init.php', $v_object, $v_var));
\V::append_data('menu', \V::load_view($this->get_view_file_path('menu', 'share'), $v_object, $v_var));
\V::append_data('body', \V::load_view($this->get_view_file_path('view'), $v_object, $v_var));
\V::output_view();
?>