<?php
$v_access_same_day_report = \E::get('obj_curr_module')->ajax_validation_check_permission("view", "same_day_report");
$v_access_reprint_report = \E::get('obj_curr_module')->ajax_validation_check_permission("view", "reprint_report");
?>
	<div class="content-header pl-0 pb-0 pt-0 mx-n3 px-0">
		<div class="container-fluid">
			<div class="row mb-2">
				<div class="col-sm-12 breadcrumb_container">
					<a href="<?php echo \E::get('obj_curr_module')->build_action_path('home', 'index'); ?>">
						<?php echo \E::get('obj_curr_module_lang')->get('SYSTEM_ADMINISTRATOR_BREADCRUMB_HOME'); ?>
					</a> /
					<?php echo \E::get('obj_curr_module_lang')->get('REPRINT_TICKET_REPORT'); ?>
				</div>
				<div class="col-sm-6 pl-3 pt-3">
					<h5 class="m-0 pb-0 module_name">
						<?php
						if ($v_controller_name == "list") {
							echo \E::get('obj_curr_module_lang')->get('REPRINT_TICKET_REPORT');
						}
						?>
					</h5>
				</div>
			</div>
		</div>
	</div>
	<hr/>
	<div class="table-responsive">
		<table class="table table-striped table-bordered">
			<thead>
			<tr>
				<th scope="col"><?php echo \E::get('obj_curr_module_lang')->get('SYSTEM_ADMINISTRATOR_NO'); ?></th>
				<th scope="col"><?php echo \E::get('obj_curr_module_lang')->get('SYSTEM_ADMINISTRATOR_FUNCTION'); ?></th>
			</tr>
			</thead>
			<tbody>
			<?php
			$v_module_counter = 0;
			if ($v_access_same_day_report == 1) { ?>
				<tr>
					<td scope="row"><?php echo ++$v_module_counter . "."; ?></td>
					<td>
						<h5>
							<a href="<?php echo \E::get('obj_curr_module')->build_action_path('same_day_report', 'list'); ?>">
								<?php echo \E::get('obj_curr_module_lang')->get('MENU_REPORT_SAME_DAY'); ?>
							</a></h5>
					</td>
				</tr>
				<?php
			}
			if ($v_access_reprint_report == 1) { ?>
				<tr>
					<td scope="row"><?php echo ++$v_module_counter . "."; ?></td>
					<td>
						<h5>
							<a href="<?php echo \E::get('obj_curr_module')->build_action_path('reprint_report', 'list'); ?>">
								<?php echo \E::get('obj_curr_module_lang')->get('MENU_REPRINT_TICKET'); ?>
							</a></h5>
					</td>
				</tr>
				<?php
			} ?>
			</tbody>
		</table>
	</div>
<?PHP
\I::load_error();
?>