<nav class="main-header navbar navbar-expand navbar-white navbar-light">
    <ul class="navbar-nav">
        <li class="nav-item">
            <a class="nav-link pl-1" data-widget="pushmenu" href="#" role="button"><i class="fas fa-bars fa-lg"></i></a>
        </li>
    </ul>
    <ul class="navbar-nav ml-auto">
        <li class="nav-item">
            <a class="nav-link p-0 m-0"
               href="<?php echo \E::get('obj_curr_module')->build_action_path('system_info', 'view') ?>">
                <i class="fa fa-info-circle fa-2x" style="color: #7C7C7C"></i>
            </a>
        </li>
        <li class="nav-item dropdown">
            <a class="nav-link p-0 m-0" data-toggle="dropdown" href="#">
                <i class="fas fa-user-circle fa-2x"></i>
            </a>
            <div class="dropdown-menu  dropdown-menu-right">
                <?php
                $v_get_user = \E::get( 'obj_curr_module')->user_get_data(\E::get_session('usr_id'));
                $v_usr_full_name = $v_get_user[0]['usr_full_name'];
                $v_usr_short_name = $v_get_user[0]['usr_short_name'];
                $v_role = $v_get_user[0]['role'];
                $v_agency = $v_get_user[0]['agency'];
                $v_location = $v_get_user[0]['location'];
                $role_type_name = "";
                if($v_location == '' && $v_agency == '' ){
                    $role_type_name = \E::get('obj_curr_module_lang')->get('SHARE_SYSTEM_ADMINISTRATOR');
                } else if($v_location == '' && $v_agency != '' ){
                    $role_type_name = \E::get('obj_curr_module_lang')->get('SHARE_AGENCY_ADMIN');
                } else if($v_location != '' && $v_agency != '' ){
                    $role_type_name = \E::get('obj_curr_module_lang')->get('SHARE_AGENCY_STAFF_MEMBER');
                }?>
                <a href="javascript:void(0);" class="dropdown-item">
                    <i class="fas fas fa-user fa-sm fa-fw mr-2 text-gray-400"></i>
                    <span class=""><?php echo $v_usr_full_name;?></span>
                </a>
                <a href="javascript:void(0);" class="dropdown-item">
                    <i class="fas fas fa-user fa-sm fa-fw mr-2 text-gray-400"></i>
                    <span class=""><?php echo $v_usr_short_name;?></span>
                </a>
                <?php
                if( $v_agency != '' ) {
                    $v_agency_data = \E::get('obj_curr_module')->agency_get_by_id( $v_agency );?>
                    <a href="javascript:void(0);" class="dropdown-item">
                        <i class="fas fas fa-building fa-sm fa-fw mr-2 text-gray-400"></i>
                        <span class=""><?php echo $v_agency_data['ag_name'];?></span>
                    </a>
                    <?php
                }
                ?>
                <?php
                if( $v_location != '' ) {
                    $v_get_location = \E::get('obj_curr_module')->location_get_by_id($v_location);?>
                    <a href="javascript:void(0);" class="dropdown-item">
                        <i class="fas fas fa-building fa-sm fa-fw mr-2 text-gray-400"></i>
                        <span class=""><?php echo $v_get_location['name'];?></span>
                    </a>
                    <?php
                }?>
                <a href="javascript:void(0);" class="dropdown-item">
                    <span style="background: green;padding: 3px 9px;border-radius: 5px;color: #FFF;"><?php echo $role_type_name;?></span>
                </a>
                <a href="<?php echo \E::get('obj_curr_module')->build_action_path('user', 'logout', '', '', 'system') ?>"
                   class="dropdown-item">
                    <i class="fas fa-sign-out-alt fa-sm fa-fw mr-2 text-gray-400"></i>
                    <span class=""><?php echo \E::get('obj_system_lang')->get('LOGOUT'); ?></span>
                </a>
            </div>
        </li>
    </ul>
</nav>
<script type="text/javascript">
    $('title').html("eTicketing");
    $('title').html("eTicketing");
</script>