<div class="container-bg">
	<div class="h-100">
		<div class="h-100 justify-content-center align-items-center login-panel-side" >
			<div class="row mb-4">
				<div style="margin:0 40px">
					<?php echo \E::get( 'obj_curr_module')->get_image_tag( 'crest.png' ); ?>
				</div>
				<div style="margin:0 40px">
					<?php echo \E::get( 'obj_curr_module')->get_image_tag( 'sfc_logo.jpg',false, 'width:75px;' ); ?>
				</div>
			</div>
			<div class="row">
				<div class="col pr-2 mb-4">	
					<h1 class="text-center mb-4" style="font-weight: 300;">
						<?php echo \E::get( 'obj_curr_module_lang' )->get( 'LOGIN_FORM_NAME_HEADING' ); ?>
					</h1>
				</div>
			</div>
			<div class="col-md-4" style="display:flex;align-items:flex-start;justify-content:center;">
				<div class="login-box login_card">
					<div class="card">
						<div class="card-body">
							<form id="frm_login" name="frm_login" method="post" onsubmit="return validate(this);" >
								<div class="row">
									<div class="col pr-2">
										<h6 class="text-center mb-4" style="font-weight: normal;">
											<?php echo \E::get( 'obj_curr_module_lang' )->get( 'SIGN_IN_TO_START_YOUR_SESSION' ); ?>
										</h6>
									</div>
								</div>
								<?php
								$v_error_msg = \I::load_error("MESSAGE", TRUE, TRUE, "");
								if( $v_error_msg != '' ) {
								?>
								<div class="row">
									<div class="col-12 p-0">
										<div class="alert alert-warning py-1">
											<a href="#" class="close" data-dismiss="alert" aria-label="close">&times;</a>
											<?php echo $v_error_msg; ?>
										</div>
									</div>
								</div>
								<?php 
								} 
								?>
								<?php
								if (isset($_SESSION['message'])) {
									$v_session_msg = $_SESSION['message'];
									if ($v_session_msg != '') {
										?>
										<div class="row">
											<div class="col-12 p-0">
												<div class="alert alert-warning py-1">
													<a href="#" class="close" data-dismiss="alert" aria-label="close">&times;</a>
													<div class="error">
													<span>
														<?php echo $v_session_msg;
														unset($_SESSION['message']);
														?>
													</span>
													</div>
												</div>
											</div>
										</div>
										<?php
									}
								}
								?>
								<div class="input-group mb-3">
									<div class="input-group-prepend">
										<span class="input-group-text"><i class="fa fa-user"></i></span>
									</div>
									<input name="txt_usr_id" type="text" class="form-control" placeholder="<?php echo \E::get( 'obj_system_lang' )->get('USER_ID') ?>" />
									<input name="txt_usr_login" value="LOGIN" type="hidden" />
								</div>
								<div class="input-group mb-4">
									<div class="input-group-prepend">
										<span class="input-group-text"><i class="fa fa-key"></i></span>
									</div>
									<input name="txt_usr_password" type="password" class="form-control" placeholder="<?php echo \E::get( 'obj_system_lang')->get('USER_PASSWORD') ?>" onKeyPress="handleKeyPress(this.name, event)" />
								</div>
								<div class="row mb-3">
									<div class="col">
										<button type="submit" class="btn btn-block btn-primary"><?php echo \E::get( 'obj_system_lang')->get('LOGIN') ?></button>
									</div>
								</div>
                                <div class="col-md-12 ">
                                    <div class="login-or">
                                        <hr class="hr-or">
                                        <span class="span-or"> <?php echo \E::get( 'obj_curr_module_lang')->get('LOGIN_OR_WITH_SARAWAK_ID') ?> </span>
                                    </div>
                                </div>
                                <div class="row mb-3">
                                    <div class="col">
										<a class="btn btn-block btn-warning" href="<?php echo \E::get('obj_curr_module')->build_action_path('home','index');?>?swkid_login">
											<?php echo \E::get('obj_curr_module_lang')->get('LOGIN_WITH_SARAWAK_ID');?>
										</a>
                                    </div>
                                </div>
							</form>
						</div>
					</div>
				</div>
			</div>
		</div>
	</div>
</div>
<script>
	$(document).ready( function(){
		$('input[name=txt_usr_id]').focus()
	});
	$("title").html("eTicketing");
</script>